uniform vec3  PhaseShift;
uniform vec3  RadialFreq;
uniform vec3  Center;
uniform vec3  WindowSize;

void main(void)
{
    float a = (gl_FragCoord.x - Center.x) / WindowSize.x;
    float b = (gl_FragCoord.y - Center.y) / WindowSize.y;
    float rho = sqrt(a*a+b*b);
    vec3 sine2;
    sine2.x = sin((rho + PhaseShift.x) * RadialFreq.x * 2.0 * 3.1416);
    sine2.y = sin((rho + PhaseShift.y) * RadialFreq.y * 2.0 * 3.1416);
    sine2.z = sin((rho + PhaseShift.z) * RadialFreq.z * 2.0 * 3.1416);
    sine2 *= sine2;
    gl_FragColor = vec4(sine2,1.0);
}
