/*
 * -----------------------------------------------------------------------
 * FIXME: this is a mess, whould get rid of it
 * Drawing stuff
 */

#ifndef	SRC_ALPHA
#define	SRC_ALPHA	0.5f
#endif

#ifndef	ORIGIN_COLOR
#define	ORIGIN_COLOR	0.8f,0.8f,0,SRC_ALPHA
#endif

#ifndef	MINOR_GRID_COLOR
#define	MINOR_GRID_COLOR	0,0.4f,0,SRC_ALPHA	
#endif

#ifndef	MAJOR_GRID_COLOR
#define	MAJOR_GRID_COLOR	0.2f,0.2f,0,SRC_ALPHA	
#endif

#ifndef	BBOX_COLOR
#define	BBOX_COLOR	0.5f,0.5f,0,SRC_ALPHA
#endif

#ifndef	MINOR_GRID_LINE_WIDTH
#define	MINOR_GRID_LINE_WIDTH	0.8f
#endif

#ifndef	MAJOR_GRID_LINE_WIDTH
#define	MAJOR_GRID_LINE_WIDTH	1.7f
#endif

#ifndef MINOR_GRID_DIVS
#define MINOR_GRID_DIVS	100
#endif

#ifndef MAJOR_GRID_DIVS
#define MAJOR_GRID_DIVS	10
#endif

typedef struct agm_globals_s
{
	vec3_t	mins, maxs;
	GLfloat alpha, beta, gamma, delta;
	GLfloat deltax, deltay;
	GLfloat fmin, fcenter, fmax, ext_scale;
	GLboolean auto_warp;
	vboolean draw_minor_grid, draw_major_grid, draw_tripod, draw_bbox;
}	agm_globals_t, *agm_globals_p;

/*
static agm_globals_t agm_default =
{
	{-1, -1, -1}, {1, 1, 1},
	0, 0, 0, 0,
	0, 0,
	4.4f, 66, 1280, 10.0f,
	GL_FALSE,
	false, true, true, true
};
*/

static agm_globals_t agm =
{
        {-1,-1,-1}, {1,1,1},
        0, -78, 0, -123,
        0.6f, 0.7f,
        2.2f, 66, 650, 3.4f,
        GL_FALSE,
        false, true, true, false
};

static void
show_agm_globals()
{
	printf("static agm_globals_t agm =\n{\n"
			"\t{%g,%g,%g}, {%g,%g,%g},\n"
			"\t%g, %g, %g, %g,\n"
			"\t%g, %g,\n"
			"\t%g, %g, %g, %g,\n"
			"\tGL_FALSE,\n\t" "false, true, true, false\n};\n",
			agm.mins[0], agm.mins[1], agm.mins[2],
			agm.maxs[0], agm.maxs[1], agm.maxs[2],
			agm.alpha, agm.beta, agm.gamma, agm.delta,
			agm.deltax, agm.deltay,
			agm.fmin, agm.fcenter, agm.fmax, agm.ext_scale);
	fflush(stdout);
}

void
agSetSceneExtents(vec3_t mins, vec3_t maxs)
{
	vec3Copy(agm.mins, mins);
	vec3Copy(agm.maxs, maxs);
}

static void
draw_xOy_grid(vec3_t origin,vec_t width,vec_t height,unsigned num_divs)
{
	unsigned i;
	vec3_t p, dp;
	vec3Copy(p,origin);
	p[0] -= (vec_t)0.5 * width;
	p[1] -= (vec_t)0.5 * height;
	vec3Set(dp,width,height,0);
	vec3Scale(dp,dp,(vec_t)1 / num_divs);
	glBegin(GL_LINES);
		/* grid along Oy direction */
		for(i = 0;i <= num_divs;i++)
		{
			glVertex3d(p[0] + i * dp[0],p[1],p[2]);
			glVertex3d(p[0] + i * dp[0],p[1] + height,p[2]);
		}
		/* grid along Ox direction */
		for(i = 0;i <= num_divs;i++)
		{
			glVertex3d(p[0],p[1] + i * dp[1],p[2]);
			glVertex3d(p[0] + width,p[1] + i * dp[1],p[2]);
		}
	glEnd(); /* GL_LINES */
}

static void
draw_2_xOy_grids(vec3_t origin,vec3_t center,vec_t width,vec_t height)
{
	vec_t dw, dh;
	vec3_t neworg;
	if(!agm.draw_minor_grid && !agm.draw_major_grid)
		return;
	dw = width / (MAJOR_GRID_DIVS - 1);
	dh = height / (MAJOR_GRID_DIVS - 1);
	vec3Copy(neworg,center);
	neworg[0] -= (vec_t)fmod(center[0] - origin[0],dw);
	neworg[1] -= (vec_t)fmod(center[1] - origin[1],dh);
	if(agm.draw_minor_grid)
	{
		glLineWidth(MINOR_GRID_LINE_WIDTH);
		glColor4f(MINOR_GRID_COLOR);
		draw_xOy_grid(neworg,width,height,MINOR_GRID_DIVS);
	}
	if(agm.draw_major_grid)
	{
		glLineWidth(MAJOR_GRID_LINE_WIDTH);
		glColor4f(MAJOR_GRID_COLOR);
		draw_xOy_grid(neworg,width,height,MAJOR_GRID_DIVS);
	}
}

static vboolean
draw(vboolean (*draw_main)(void))
{
	vboolean result;
	vec3_t origin, center;
	vec_t scale, se;
	/* Here we can recompute bounding box */
/*
	if(scene_mesh)
	{
		int i;
		bboxClear(agm.mins, agm.maxs);
		for(i = 0;i < scene.num_vertices;i++)
			bboxAddPoint(agm.mins, agm.maxs, scene.vertex[i]);
	}
*/
	/* translate to center of all objects */
	vec3Zero(origin);
	vec3Sub(center,agm.maxs,agm.mins); /* extents */
	scale = 4.0f / vec3Abs(center);
	vec3Add(center,agm.mins,agm.maxs);
	vec3Scale(center,center,0.5f);

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();

	glRotatef(agm.gamma,0,0,1);

	glTranslatef(0,0,-agm.fcenter);
	se = scale * agm.ext_scale; /* preserve 'scale' */
	glScaled(se,se,se); 

	glTranslatef(agm.deltax,agm.deltay,0);

	glRotatef(agm.alpha,0,1,0);
	glRotatef(agm.beta,1,0,0);
	glRotatef(agm.delta,0,0,1);

	glTranslated(-center[0],-center[1],-center[2]);

	/* Draw scene */
	glPushMatrix();
	result = draw_main();
	glPopMatrix();
	/* Draw coordsys-aligned grid on xOy plane */
	draw_2_xOy_grids(origin,center,10,10);
	/* Origin and axes */
	if(agm.draw_tripod)
	{
		glLineWidth(4.0f);
		glBegin(GL_LINES);
			glColor4f(.9f,.3f,.3f,SRC_ALPHA);
			glVertex3f(0,0,0);
			glVertex3f(1,0,0);
			glColor4f(.3f,.9f,.3f,SRC_ALPHA);
			glVertex3f(0,0,0);
			glVertex3f(0,1,0);
			glColor4f(.3f,.3f,.9f,SRC_ALPHA);
			glVertex3f(0,0,0);
			glVertex3f(0,0,1);
		glEnd();
		glPointSize(6.0f);
		glBegin(GL_POINTS);
			glColor4f(ORIGIN_COLOR);
			glVertex3fv(origin);
		glEnd();
	}
	if(agm.draw_bbox)
	{
		glColor4f(BBOX_COLOR);
		glLineWidth(2.0f);
		bboxDraw(agm.mins, agm.maxs);
	}
	agSwap();
	return result;
}

/*
 * -----------------------------------------------------------------------
 * Part 6: Camera Control
 */
static vboolean paused = true;
/*
static int autopause = 0;
*/

static void
correct_frustum(void)
{
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glFrustum(-1,1,-1,1,agm.fmin,agm.fmax);
	glMatrixMode(GL_MODELVIEW);
}

static vboolean
handle_event_check_break(ui_event_p in,
	vboolean (*next_check_break)(ui_event_p ev))
{
	switch(in->type)
	{
		case ui_key_event:
			if(in->key.press)
			{
				switch(in->key.scan)
				{
					case sc_escape:
						return 1;
					case sc_wheelup:
					case sc_minus:
					case sc_kp_subtract:
						agm.fmin *= 0.9f;
						agm.fmax *= 0.9f;
						/*
						agm.fcenter = (agm.fmin + agm.fmax) * 0.5f;
						*/
						agm.ext_scale *= 0.85f;
						correct_frustum();
						break;
					case sc_wheeldown:
					case sc_equal:
					case sc_kp_add:
						agm.fmin *= 1.1f;
						agm.fmax *= 1.1f;
						agm.ext_scale *= 1.15f;
						/*
						agm.fcenter = (agm.fmin + agm.fmax) * 0.5f;
						*/
						correct_frustum();
						break;
					case sc_space:
					case sc_kp_begin:
						agm.alpha = agm.beta = agm.deltax = agm.deltay = agm.gamma = agm.delta = 0;
						break;
					case sc_up:
						agm.deltay -= 0.1f;
						break;
					case sc_kp_up:
						agm.beta += 3;
						break;
					case sc_down:
						agm.deltay += 0.1f;
						break;
					case sc_kp_down:
						agm.beta -= 3;
						break;
					case sc_left:
						agm.deltax += 0.1f;
						break;
					case sc_kp_left:
						agm.alpha -= 3;
						break;
					case sc_right:
						agm.deltax -= 0.1f;
						break;
					case sc_kp_right:
						agm.alpha += 3;
						break;
					case sc_kp_home:
						agm.gamma += 3;
						break;
					case sc_kp_prior:
						agm.gamma -= 3;
						break;
					case sc_kp_end:
						agm.delta += 3;
						break;
					case sc_kp_next:
						agm.delta -= 3;
						break;
					case sc_w:
						if(agm.auto_warp)
							agm.auto_warp = GL_FALSE;
						else
							agm.auto_warp = GL_TRUE;
						uiAutoWarp(agm.auto_warp);
						break;
	/*
					case sc_a:
						autopause = !autopause;
						break;
	*/
					case sc_p:
						paused = !paused;
						break;
					case sc_i:
						agm.draw_minor_grid = !agm.draw_minor_grid;
						break;
					case sc_o:
						agm.draw_major_grid = !agm.draw_major_grid;
						break;
					case sc_t:
						agm.draw_tripod = !agm.draw_tripod;
						break;
					case sc_f12:
						show_agm_globals();
						break;
				}
			}
			break;
		case ui_wm_event:
			switch(in->configure.wm_event)
			{
				case ui_wm_close:
					return true;
			}
			break;
		case ui_pointer_motion_event:
			if((in->button & UI_LBUTTON_MASK) || 
				(agm.auto_warp && !(in->button & UI_RBUTTON_MASK)))
			{
				agm.alpha += in->client_dx;
				agm.beta += in->client_dy;
			}
			if(in->button & UI_RBUTTON_MASK)
			{
				agm.deltax += 0.05f * in->client_dx / agm.ext_scale;
				agm.deltay -= 0.05f * in->client_dy / agm.ext_scale;
			}
			break;
		default:
			break;
	}
	return next_check_break ? next_check_break(in) : false;
}

static void
agMainLoopEx(vboolean (*draw_main)(void),
			 vboolean (*next_check_break)(ui_event_p),
			 vboolean (*compute_progress)(void*),
			 void *compute_progress_arg,
			 vboolean (*idle)(void*),
			 void *idle_arg)
{
	static unsigned computation_time = 20; /* 50 FPS max */
	static unsigned lastdraw_time = 0;
	ui_event_t in;
	correct_frustum();
	for(;;)
	{
		while(uiPending())
		{
			uiNextEvent(&in);
			if(handle_event_check_break(&in, next_check_break))
				goto good_bye;
		}
		if(!paused)
		{
			if(compute_progress)
				if(!compute_progress(compute_progress_arg))
					break;
		}
		else
		{
			if(idle)
			{
				if(!idle(idle_arg))
					break;;
			}
			else
				agSleep(computation_time);
		}
		if(agTickCount() - lastdraw_time > computation_time)
		{
			if(!draw(draw_main))
				break;
			lastdraw_time = agTickCount();
		}
	}
good_bye:;
}

static void
agMainLoop(vboolean (*draw_main)(void),
	vboolean (*next_check_break)(ui_event_p ev))
{
	agMainLoopEx(draw_main, next_check_break, NULL, NULL, NULL, NULL);
}
